'use strict'
var qs = require('querystring');
var axios = require('axios');
var HttpsProxyAgent = require("https-proxy-agent");

var getContentType = function (config) {
    var head = config.headers;
    return head['Content-Type'] || 'application/json';
}

function Http(opts) {
    var http = axios.create(opts);
    http.interceptors.request.use(function (config) {
        // request interceptor
        if (typeof config.data === 'object'&&getContentType(config).indexOf('x-www-form-urlencoded')!=-1) {
            config.data = qs.stringify(config.data)
        }
        return config;
    }, function (error) {
        //request error
        return Promise.reject(error);
    });

    http.interceptors.response.use(function (response) {
        // response interceptor
        return response.data;
    }, function (error) {
        // response error,format error.
        // var err = new Error(error.message);
        // err.code = error.response.status;
        // err.config = error.config;
        // err.data = error.response.data;
        // err.stack = error.stack;
        return Promise.reject(error);
    });
    //设置代理服务器，全局默认
    http.setProxy=function(proxyUrl){
        const httpsAgent = new HttpsProxyAgent(proxyUrl);
        http.defaults.proxy=false;
        http.defaults.httpsAgent=httpsAgent;
    }
    return http;
}
module.exports = Http;