
// declare function util(...args: any[]): void;
declare namespace util {
    //datetime
    function addDate(date: any, type: string, inc: number): any;
    function addDay(date: any, inc: number): any;
    function addHour(date: any, inc: number): any;
    function addMinute(date: any, inc: number): any;
    function addMonth(date: any, inc: number): any;
    function addSecond(date: any, inc: number): any;
    function addWeek(date: any, inc: number): any;
    function addYear(date: any, inc: number): any;
    function dayTime(date: any, inc: number): any;
    function formatDate(date: any, format: string): any;
    function fromNow(start: any): any;
    function getTimeByObjectId(objectId: any): any;
    function isDate(value: any): any;
    function setDay(date: any, inc: number): any;
    function toDate(value: any): any;

    //array
    function chunk(array: any[], num: number): any;
    function compact(arr: any[]): any;
    function concat(...args: any[]): any;
    function drop(array: any[], num: number): any[];
    function dropRight(array: any[], num: number): any[];
    function find(objects: any, cons: any): any;
    function findIndex(objects: any, obj: any): any;
    function findOne(objects: any, obj: any): any;
    function flatten(arr: any[]): any[];
    function indexOf(arr: any[], value: any): any;
    function kv(arr: Array<any>, key: any): any;
    function map(objects: Array<any>, fn: any): any;
    function max(arr: Array<any>, key?: any): any;
    function min(arr:  Array<any>, key?: any): any;
    function merge(...args: any[]): any;
    function notIn(...args: any[]): any;
    function sort(arr: Array<any>, keys: string): Array<any>;
    function sortRandom(arr: Array<any>): Array<any>;
    function uniq(arr: Array<any>): Array<any>;
    function values(objects: Array<any>, key: any): any;
    function xor(...args: any[]): any;
    //object
    function clone(objects: any): any;
    function extend(...args: any[]): any;
    function formatObj(obj: any): any;
    function is(value: any, other: any): any;
    function isJson(str: string): any;
    function isNullObj(obj: any): any;
    function isObject(value: any): any;
    function isPlainObject(value: any): any;
    function querystring(obj: any): any;
    function sortObj(obj: any): any;

    //string
    function encodeUrl(value: string): any;
    function decodeUrl(value: string): any;
    function format(f: string, ...args: any[]): any;
    function formatIp(ip: string): string;
    function formatMoney(obj: any): any;
    function isString(str: any): any;
    function toText(html: string, length?: number): any;
    function trim(str: string): any;
    function uuid(): string;
    //index
    function sign(obj: any, key: string): string;
    function use(fn: any): void;
    function sleep(ms: any): Promise<void>;
    //crypto
    function hash(method: string, input: string, format: string): any;
    function hmac(data: string, key: string, algorithm: string, encoding: string): any;
    function aesDecode(str: any, key: number): any;
    function aesEncode(str: string, key: string): any;
    function base64Decode(encodeStr: string, urlsafe?: boolean, encoding?: string): any;
    function base64Encode(str: string, urlsafe?: boolean): any;
    function md5(str: string, bit?: number): any;
    function sha1(str: string, format: string): string;
    function sha256(str: string, format: string): string;

    //number
    function isInt(value: any): any;
    function isNumber(value: any): any;
    function random(start: number, end: number): any;
    function round(number: number, precision: number): any;
    function toFixed(num: number, bit: number): any;
    function toInt(value: any): any;
    function toNumber(value: any): any;
    //convert
    function isStream(value: any): any;
    function toArray(value: any, mod: string): any;
    function toBuffer(value: any, mod: string): any;
    function toJson(value: any): any;
    function toStream(value: any): any;
    function toString(value: any, mod: any): any;
    function unzip(value: any): any;

    namespace fs {
        function exist(file: string): Promise<boolean>;
        function ll(dir: string, root?: string): Promise<Array<any>>;
        function readDir(dir: string): Promise<Array<any>>;
        function mkdir(path: string, mode?: string): Promise<any>;
        function mv(src: string, dest: string): Promise<any>;
        function cp(src: string, dest: string, mode?: number): Promise<any>;
        function readFile(path: string, options?: any): Promise<any>;
        function readGzip(path: string): Promise<any>;
        function rmrf(path: string): Promise<any>;
        function stat(path: string): Promise<any>;
        function writeFile(file: string, data: any, options?: any): Promise<any>;
    }
    //http
    function Http(opts: any): any;
    function http(...args: any[]): any;
    namespace http {
        const interceptors: {
            request: {
                eject: any;
                forEach: any;
                handlers: {
                    fulfilled: any;
                    rejected: any;
                    runWhen: any;
                    synchronous: boolean;
                }[];
                use: any;
            };
            response: {
                eject: any;
                forEach: any;
                handlers: {
                    fulfilled: any;
                    rejected: any;
                    runWhen: any;
                    synchronous: boolean;
                }[];
                use: any;
            };
        };

        function get(...args: any[]): any;

        function getUri(...args: any[]): any;

        function head(...args: any[]): any;

        function options(...args: any[]): any;

        function patch(...args: any[]): any;

        function post(...args: any[]): any;

        function put(...args: any[]): any;

        function request(...args: any[]): any;

        namespace defaults {
            const headers: {
                "Content-Type": string;
                common: {
                    Accept: string;
                };
                delete: {
                };
                get: {
                };
                head: {
                };
                patch: {
                    "Content-Type": string;
                };
                post: {
                    "Content-Type": string;
                };
                put: {
                    "Content-Type": string;
                };
            };

            const maxBodyLength: number;

            const maxContentLength: number;

            const timeout: number;

            const transformRequest: any[];

            const transformResponse: any[];

            const transitional: {
                clarifyTimeoutError: boolean;
                forcedJSONParsing: boolean;
                silentJSONParsing: boolean;
            };

            const xsrfCookieName: string;

            const xsrfHeaderName: string;

            function adapter(config: any): any;

            function validateStatus(status: any): any;
        }

    }

    namespace qs {
        function decode(qs: any, sep: any, eq: any, options: any): any;

        function encode(obj: any, sep: any, eq: any, options: any): any;

        function escape(str: any): any;

        function parse(qs: any, sep: any, eq: any, options: any): any;

        function stringify(obj: any, sep: any, eq: any, options: any): any;

        function unescape(s: any, decodeSpaces: any): any;

        function unescapeBuffer(s: any, decodeSpaces: any): any;

    }

    namespace zip {
        function unzip(src: string, dist: string): any;
        function zip(src: string, dist: string, opts: any): any;
    }

}

export default util;

